package com.yuandian.dataflow.controller;

import java.io.IOException;
import java.time.Instant;
import java.util.ArrayList;
import java.util.List;
import java.util.Queue;
import java.util.Random;
import java.util.concurrent.ConcurrentLinkedQueue;
import java.util.concurrent.CountDownLatch;
import java.util.concurrent.ThreadLocalRandom;
import java.util.concurrent.TimeUnit;
import java.util.concurrent.atomic.AtomicInteger;

import com.alipay.sofa.jraft.Status;
import com.alipay.sofa.jraft.entity.PeerId;
import com.alipay.sofa.jraft.error.RemotingException;
import com.alipay.sofa.jraft.rpc.InvokeCallback;
import com.google.protobuf.Any;
// import com.yuandian.dataflow.controller.PacketsProcessor.PacketsRequest;
import com.yuandian.dataflow.proto.msgtype.BacktrackingFlowOuterClass;
import com.yuandian.dataflow.statemachine.StateServerFactory;
import com.yuandian.dataflow.statemachine.annotations.MasterRegister;
import com.yuandian.dataflow.statemachine.master.MasterContext;
import com.yuandian.dataflow.statemachine.master.MasterExecute;
import com.yuandian.dataflow.statemachine.state.Peer;
import com.yuandian.dataflow.statemachine.state.State;
import com.yuandian.dataflow.statemachine.state.WorkerState;
import com.yuandian.dataflow.utils.PacketsManager;
import com.yuandian.dataflow.utils.Utils;

import lombok.extern.slf4j.Slf4j;

@Slf4j
@MasterRegister
public class MasterProcessor implements MasterExecute {

    // ConcurrentLinkedQueue<Any> packets = new ConcurrentLinkedQueue<>();

    PacketsManager packetsManager = new PacketsManager();

    @Override
    public void loop(MasterContext cxt) {
        // ArrayList<Any> packets = new ArrayList<>();
        // 模拟发送包的数据到该节点上

        for (int i = 0; i < ThreadLocalRandom.current().nextLong(50, 100); i++) {
            var p = Any.pack(BacktrackingFlowOuterClass.BacktrackingFlow
                    .newBuilder()
                    .setTableId(10086)
                    .build());
            packetsManager.addPacket(p);
            // packets.add(p);
        }

        try {

            var giter = StateServerFactory.stateServer.getRaftServer().getGroups().iterator();
            var iter = giter.next().getPeers().iterator();

            if(iter.hasNext()) {
                cxt.sleep(100);
                return;
            }

            var peers = new ArrayList<Peer>();
            while (iter.hasNext()) {
 
                var curPeer = iter.next();

                if (packetsManager.size() >= 100000) {
                    log.error("告警 数据流无法正常消耗: 缓冲packets:{} 直接放弃一部分数据", packetsManager.size());
                    packetsManager.discardPackets(50000);
                    log.debug("master({}) execute {} packets: {}", StateServerFactory.getPeer(), curPeer,
                            packetsManager.size());
                    cxt.sleep(5000);
                }
            }
        } catch (IOException e) {
            e.printStackTrace();
        }

        // // 必须复制. raft有一直使用该list
        // var alivePeers = List.copyOf(StateFactory.getRaftNode().listAlivePeers());

        // if ( Operate.packetsManager.size() >= 100000) {
        // log.error("告警 数据流无法正常消耗: 缓冲packets:{} 直接放弃一部分数据",
        // Operate.packetsManager.size());
        // Operate.packetsManager.discardPackets(50000);
        // log.debug("master({}) execute {} packets: {}", StateFactory.getServerId(),
        // alivePeers,
        // Operate.packetsManager.size());
        // cxt.sleep(5000);
        // } else {
        // // log.debug("master({}) execute {} packets: {}", StateFactory.getServerId(),
        // // alivePeers, Operate.packetsManager.size());
        // }

        // if (alivePeers == null) {
        // cxt.sleep(100); // 休眠100毫秒.
        // return;
        // }

        // PeerId[] peers = new PeerId[alivePeers.size()];
        // alivePeers.toArray(peers);
        // // 等待全部反馈后才能进入下次循环

    }

    // /**
    // * 最大任务数限制
    // */
    // private final int MAX_TASKS = 1000;
    // private final int DEFAULT_ASYNC_TIMEOUT = 5000;

    // @Override
    // public void loop(MasterContext cxt) {

    // // ArrayList<Any> packets = new ArrayList<>();
    // // 模拟发送包的数据到该节点上

    // for (int i = 0; i < ThreadLocalRandom.current().nextLong(50, 100); i++) {
    // var p = Any.pack(BacktrackingFlowOuterClass.BacktrackingFlow
    // .newBuilder()
    // .setTableId(10086)
    // .build());
    // Operate.packetsManager.addPacket(p);
    // // packets.add(p);
    // }

    // // 必须复制. raft有一直使用该list
    // var alivePeers = List.copyOf(StateFactory.getRaftNode().listAlivePeers());

    // if ( Operate.packetsManager.size() >= 100000) {
    // log.error("告警 数据流无法正常消耗: 缓冲packets:{} 直接放弃一部分数据",
    // Operate.packetsManager.size());
    // Operate.packetsManager.discardPackets(50000);
    // log.debug("master({}) execute {} packets: {}", StateFactory.getServerId(),
    // alivePeers,
    // Operate.packetsManager.size());
    // cxt.sleep(5000);
    // } else {
    // // log.debug("master({}) execute {} packets: {}", StateFactory.getServerId(),
    // // alivePeers, Operate.packetsManager.size());
    // }

    // if (alivePeers == null) {
    // cxt.sleep(100); // 休眠100毫秒.
    // return;
    // }

    // PeerId[] peers = new PeerId[alivePeers.size()];
    // alivePeers.toArray(peers);
    // // 等待全部反馈后才能进入下次循环

    // Operate.CallOperate(new Operate(OperateType.ALLOCATE_PACKETS, alivePeers),
    // new GenericClosure() {

    // @Override
    // public void run(Status status) {
    // int[] allocTasks = this.getValue();

    // if(allocTasks == null) {
    // cxt.sleep(5000);;
    // return;
    // }

    // var all = 0;
    // for(var i : allocTasks) {
    // all += i;
    // }
    // if(all != 0) {
    // log.info("需要处理的任务数量[{}] :{}", StateFactory.getLeaderId(), allocTasks);
    // }
    // for (int i = 0; i < peers.length; i++) {

    // var peer = peers[i];
    // if (allocTasks[i] <= 0) {
    // continue;
    // }
    // var packets = Operate.packetsManager.popPackets(allocTasks[i]);
    // // 先提交 节点的 剩余能处理的任务数量. 然后再处理
    // var request = new PacketsRequest(); // 数据包切片
    // request.setPackets(packets);

    // try {
    // StateFactory.rpcClientInvokeAsync(peer.getEndpoint(), request,
    // new InvokeCallback() {
    // @Override
    // public void complete(Object result, Throwable err) {

    // if (err != null) {
    // // TODO: 如果错误, 需要让节点恢复任务处理的状态
    // log.debug("{}", err);
    // }
    // // log.debug("PacketsRequest: {}", result);
    // }
    // }, DEFAULT_ASYNC_TIMEOUT);
    // } catch (InterruptedException | RemotingException e) {
    // log.info("error send packets {}", e.toString());
    // }
    // }
    // }
    // });

    // }

}
